import sys
import random


def make_big_rooms(a):
    return [d[x] for x in a]

with open('input.txt', 'wt') as f:
    n1, n2, m1, m2, levels, big_rooms, rs = map(int, sys.argv[1:])
    random.seed(rs)
    n, m, d = random.randint(n1, n2), random.randint(m1, m2), {}
    if big_rooms:
        d = {x: random.randint(0, 10 ** 9 - 1) for x in range(m)}
    f.write('{} {}\n'.format(n, 10 ** 9 if big_rooms else m))

    if levels < 0:
        spread = [y for x in range(n - 1) for y in range(m)] if levels == -1 else []
        for i in range(n):
            k = random.randint(1, m)
            if levels == -1:
                access = list(set(random.sample(spread, m)))
                random.shuffle(access)
            else:
                access = random.sample(list(range(m)), k)
            if big_rooms:
                access = make_big_rooms(access)
            f.write('{} '.format(len(access)) + ' '.join(map(str, access))+'\n')

    else:
        levels = random.randint(min(n, m)//2, min(n, m)) if levels == 0 else levels

        # Распределяем кабинеты по уровням случайным образом
        snips = sorted([0] + random.sample(list(range(1, m)), levels-1) + [m])
        rooms = list(range(m))
        random.shuffle(rooms)
        level_set = [rooms[snips[i]:snips[i+1]] for i in range(levels)]

        # Генерируем количество сотрудников на разных уровнях
        partition = sorted([n] + random.sample(list(range(1, n)), levels-1), reverse=True)

        # Записываем права доступа для каждого сотрудника
        selection, access = list(range(n)), [[] for _ in range(n)]
        for i, x in enumerate(partition):
            selection = random.sample(selection, x)
            for j in selection:
                access[j] += level_set[i]

        for x in access:
            random.shuffle(x)
            if big_rooms:
                x = make_big_rooms(x)
            f.write('{} '.format(len(x)) + ' '.join(map(str, x))+'\n')
